<?php

    require 'config.php';
    ini_set('error_reporting', E_ALL);
    ini_set('display_errors', 1);
    ini_set('display_startup_errors', 1);
    error_reporting(-1);  
    $querydata = GetQueryData();
    $update = json_decode($querydata['body'], true);
    $update_id = (int)$update['update_id']; // ид обновления
    
    $db = Connect($db_data); // db_data - доступ к базе, в конфиге
    
    $bot = isset($querydata['params']['action']) ? $querydata['params']['action'] : '';
    switch($bot){
            case 'bot3': {
               Message($bot, ['output'=>AddData($db, $bot, $querydata['body']), 'input'=>$querydata]);
            }
            break;
            case 'bot2': {
               Message($bot, ['output'=>AddData($db, $bot, $querydata['body']), 'input'=>$querydata]);
            }
            break;
            
            case 'zpbot2_get': {
               Message($bot, ['output'=>GetData($db, 'bot2'), 'input'=>$querydata]);
            }
            break;
            case 'zpbot2_delete': {
               Message($bot, ['output'=>Delete($db, 'bot2', $querydata['params']['id']), 'input'=>$querydata]);
            }
            break;
            
            default: {
                Message('error', ['output'=>'Этот бот не обслуживается', 'input'=>$querydata]);    
            }
            break;
    }   
    
    exit; // Завершаем работу скрипта
    
    // Удаление строк по ИД
   function Delete($db, $table, $id){
        $sql = "DELETE FROM `{$table}` WHERE `id` = :id AND 1=1 LIMIT 1";
        $st = $db->prepare($sql);
       	$st->execute(['id'=>$id]);
	$count=$st->rowCount();
	$array = ['count_delete'=> $count];
        return $array;
   } 
   
   // Получение строи с изменением статуса
   
   function GetData($db, $table){
           
           $result = ['status_0'=> '-1','status_1'=>'-1', 'row'=>''];
           $st = $db->beginTransaction();
           
           $array = ['status_1'=> 1];
           $st = $db->prepare("SELECT Count(`id`) as count FROM `{$table}` WHERE `status` = :status_1");
           $st->execute($array);
           $count = $st->fetch(PDO::FETCH_ASSOC);
           $result['status_1'] = (int)$count['count'];
           
           $array = ['status_0'=> 0];
           $st = $db->prepare("SELECT Count(`id`) as count FROM `{$table}` WHERE `status` = :status_0");
           $st->execute($array);
           $count = $st->fetch(PDO::FETCH_ASSOC);
           $result['status_0'] = (int)$count['count'];
           
           if($result['status_0'] > 0) {
                   $array = ['status_0'=> 0];
                   $sql = "SELECT * FROM `{$table}` WHERE `status` = :status_0 ORDER BY `timestamp` ASC LIMIT 1";
                   $st = $db->prepare($sql);
                   $st->execute($array);
                   $row = $st->fetch(PDO::FETCH_ASSOC);
                   $id = isset($row['id']) ? $row['id'] : '';
                   
                   if(!empty($id)){
                      $result['row'] = $row;
                      $array = ['status_0'=> 0, 'id'=> $id];
                      $sql = "UPDATE `{$table}` SET `status` = 1 WHERE `status` = :status_0 AND `id` = :id LIMIT 1";
                      $st = $db->prepare($sql);
                      $st->execute($array);
                      $count = $st->rowCount();
                      if(!($count > 0)){
                        $result['row'] = '';
                      }     
                   }
           }
           
           $db->commit();
           return $result;                      
   } 
    
    // Добавление данных в базу
   function AddData($db, $table, $json){
      if(empty($json)){
       // return ['message'=> 'запрос должен содержать тело']; // пока тестируем - закомментировано
      }
      if(CreateTable($db, $table)){
        $sql = "INSERT INTO `{$table}` (`id`, `json`, `timestamp`) VALUES(:md5, :json, :time)";
        $md5 = md5($json.microtime());
        $time = time();
        $st = $db->prepare($sql);
        $st->execute(['md5'=>$md5, 'json'=>$json, 'time'=> $time ]);
        $count=$st->rowCount();
        return ['message'=> $count]; 
      }
      return ['message'=> 'error add'];
   } 
    
    // Создание новой таблички
   function CreateTable($db, $table){
           if(!CheckTable($db, $table)){
             $sql = "CREATE TABLE `{$table}` (`id` varchar(32) NOT NULL, `json` text, `status` int(3) DEFAULT '0', `timestamp` int(11) DEFAULT '0', PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;";
             $data = $db->prepare($sql);
             $data->execute();
             return CheckTable($db, $table);
           }
           return true;
           
   }
    
    // Ниже пошли функции обработки
    function ToJson($data){
        return json_encode($data, JSON_UNESCAPED_UNICODE+JSON_PRETTY_PRINT);
    }
    
    // Показываем результат
    function Message($method, $parameters) {
        $parameters["method"] = $method;    
        $payload = ToJson($parameters);
        header('Content-Type: application/json');
        header('Content-Length: '.strlen($payload));
        echo $payload;    
        return true;
    }
    
    // Получаем данные запроса
    function GetQueryData(){
        $method = GetQueryMethod();
        $url = GetQueryUrl();
        $params = GetQueryParams($url);
        $body = '';
        if($method === 'POST') $body = GetQueryBody();

        $data = [
            'method'=> $method,
            'url' => $url,
            'params' =>$params,
            'body' =>$body            
        ];
        return $data;
    }
    
    // Извлекаем тело запроса
    function GetQueryBody(){
        $content = file_get_contents("php://input");
        return $content;
    }
    
    // Извлекаем тело строки
    function GetQueryParams($url){
        $query_str = parse_url($url, PHP_URL_QUERY);
        parse_str($query_str, $query_params);
        return $query_params;
    }
    
    // Получаем параметры запроса
    function GetQueryUrl(){
        $key = 'REQUEST_URI';
        return GetHeader($key);
    }
    
    // Получаем тип запроса
    function GetQueryMethod(){
        $key = 'REQUEST_METHOD';
        return GetHeader($key);
    }
    
    // Получаем заголовок запроса
    function GetHeader($key){
        if(isset($_SERVER[$key])) return (string)$_SERVER[$key];
        return '';
    }
    
    // Проверяем наличие таблицы в базе
     function CheckTable($db, $name){
        $sql = "SHOW TABLES LIKE '$name'";
        $exists = $db->prepare($sql);
        $exists->execute();
        return $exists->rowCount() > 0;
    }
    
    // Строка подключения
    function GetDSN($db_data){
        $dbdata = [
            "host" => $db_data['db_host'], // определен в конфиге...
            "dbname" => $db_data['db_name'],
            'charset' => 'utf8mb4'
        ];

        $dsn = '';
        foreach ($dbdata as $key => $value) {
            $dsn = empty($dsn) 
                ? implode("=", [$key, $value]) 
                : implode(";",[$dsn, implode("=", [$key, $value])]);
        }
        $dsn = implode(":", ["mysql", $dsn]);
        return $dsn;
    }
    
    // Объект для подключения к базе
    function Connect($db_data) {
        $dsn = GetDSN($db_data);
        try {
            $pdo = new PDO($dsn, $db_data['db_user'], $db_data['db_password'], array(PDO::ATTR_PERSISTENT => true)); // кеширую соединение
            return $pdo;
        }
        catch (PDOException $e) {
            die(json_encode(['error'=>'error db', "e"=>$e->getMessage()], JSON_PRETTY_PRINT));
            exit();
        }
    }
?>